remove unused file
[iankelling.org] / setup.sh
index 59f3009bd8a45c327c05d8c5909d0e85e0a1805f..f081135e3b0f253544d1f2a1981cb939ca6cfd09 100755 (executable)
--- a/setup.sh
+++ b/setup.sh
@@ -1,4 +1,4 @@
-#!/bin/bash -l
+#!/bin/bash
 # Copyright (C) 2016 Ian Kelling
 
 # This program is free software: you can redistribute it and/or modify
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-# This script depends on a few other git repos of mine, such as
-# distro-functions, basic-https-conf, acme-tiny-wrapper
+set -e; . /usr/local/lib/bash-bear; set +e
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+usage() {
+  cat <<EOF
+Usage: ${0##*/} [OPTIONS] [DOMAIN_NAME] [LETSENCRYPT_EMAIL]
+Setup dependencies, apache, and gitweb. Then call build.rb.
 
-script_dir=$(readlink -f "${BASH_SOURCE%/*}")
-cd "$script_dir"
+Default DOMAIN_NAME is iankelling.org. Domain is expected to resolve
+so we can get a let's encrypt cert.
+
+This script depends on a few other git repos of mine: distro-functions
+and basic-https-conf.
+
+
+-p PORT      Apache port, default is 443.
+-h|--help    Print help and exit.
+
+Note: Uses GNU getopt options parsing style
+EOF
+  exit $1
+}
+
+##### begin command line parsing ########
+
+
+port=443
+temp=$(getopt -l help, sp:h "$@") || usage 1
+eval set -- "$temp"
+while true; do
+  case $1 in
+    -s) allow_symlinks_arg=-s; shift ;;
+    -p) port=$2; shift 2 ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
+  esac
+done
+
+##### end command line parsing ########
+
+x="$(readlink -f "$BASH_SOURCE")"
+script_dir=${x%/*}
+cd $script_dir
 
 domain=${1:-iankelling.org} # use argument for testing site
+email=$2
+if [[ $email ]]; then
+  email_arg="-e $email"
+fi
 gitroot=/a/bin/githtml
 
+if [[ $EUID != 0 ]]; then
+  s=sudo
+fi
+
+deb8=false
+if grep -xFq 'VERSION_ID="8"' /etc/os-release; then
+  deb8=true
+fi
+
 shopt -s extglob
 
-type -P a2enmod &>/dev/null || pi apache2
-type -P sqlite3 &>/dev/null || pi sqlite3
+type -P a2enmod &>/dev/null || $s apt-get -y install apache2
+type -P sqlite3 &>/dev/null || $s apt-get -y install sqlite3
+type -P ffmpeg &>/dev/null || $s apt-get -y install ffmpeg
 
-acme-tiny-wrapper $domain
 
 pkgs=(
-    # build.rb dependencies
-    ruby-pygments.rb ruby-safe-yaml ruby-sass
-    # python pkgs used for o(n^2) voting blog entry
-    python-bcrypt python-passlib
-    # gitweb pkgs
-    gitweb highlight
+  # build.rb dependencies
+  ruby-pygments.rb ruby-safe-yaml ruby-sass
+  # python pkgs used for o(n^2) voting blog entry
+  # # commented out, needs update to python3
+  #python-bcrypt python-passlib
+  # gitweb pkgs
+  gitweb highlight
 )
-if isdebian-stable; then
-    pkgs+=(build-essential ruby-dev)
+if $deb8; then
+  pkgs+=(build-essential ruby-dev)
 else
-    pkgs+=(ruby-redcarpet)
+  pkgs+=(ruby-redcarpet)
 fi
-
+source /a/bin/distro-functions/src/package-manager-abstractions
 pi ${pkgs[@]}
-if isdebian-stable; then
-    sudo gem install redcarpet
+if $deb8; then
+  sudo gem install redcarpet
 fi
 chmod og+x _site/on2vote/vote.py
 
@@ -60,11 +109,11 @@ chmod og+x _site/on2vote/vote.py
 # It's example apache config seems to say we can use cgi or cgid,
 # and googling cgid it seems a newer faster alternative. I also
 # depend on this in my o(n^2) python script.
-sudo a2enmod cgid
+$s a2enmod cgid
 
 
 # additional settings from browsing https://git-scm.com/docs/gitweb.conf
-s dd of=/etc/gitweb.conf <<EOF
+$s dd of=/etc/gitweb.conf <<EOF
 \$feature{'highlight'}{'default'} = [1];
 # highlighting doesn't work on files without extension.
 # I noticed in terminal "highlight file" won't do it (unknown file type)
@@ -85,15 +134,17 @@ our \$site_footer = '$PWD/_site/gitweb-footer.html';
 push @stylesheets, "/css/gitweb-site.css";
 our \$favicon = '/assets/favicon.png';
 # default is 25, cuts off descriptions.
-our \$projects_list_description_width = 40;
+our \$projects_list_description_width = 50;
 # a bit superflous since they are all me
 our \$omit_owner = true;
 # highlight scripts with no extension, uses a patch
 # that is on it's way upstream.
 our \$highlight_force = 1;
+our \$home_text = "$script_dir/_site/gitweb_home.html";
+our \$projects_list_group_categories = 1;
 EOF
 
-apache-site - $domain <<EOF
+web-conf $allow_symlinks_arg $email_arg -p $port - apache2 $domain <<EOF
 # to run python script on my site:
 <Directory /var/www/$domain/html/on2vote>
   # to run python scripts with cgi
@@ -101,6 +152,11 @@ apache-site - $domain <<EOF
   AddHandler cgi-script .py
 </Directory>
 
+<Directory /var/www/$domain/html/stream-videos/>
+  Options Indexes
+</Directory>
+
+
 <Directory "/var/www/$domain/html/cgi">
   Options +ExecCGI
   SetHandler cgi-script
@@ -159,4 +215,5 @@ EOF
 $script_dir/gitweb-descriptions $gitroot
 
 $script_dir/build.rb
-s lnf -T $script_dir/_site /var/www/$domain/html
+$s rm -rf /var/www/$domain/html
+$s ln -sT $script_dir/_site /var/www/$domain/html